C			* * * * *
C
C	WATER AND HEAT BALANCE OF BARE SOIL- NO RUNOFF
C	VAN BAVEL - LASCANO   21 MAY 1979
C	PROGRAM USED FOR USER'S GUIDE PREPARATION
C	CONSERVB VARIATION#6 
C
C       CONVERTED FROM CSMP III INTO FORTRAN  
C         APRIL 1986 BY HAMISH P. CRESSWELL
C            (MICROSOFT FORTRAN VERSION)
C             HOURLY DATA INPUT VERSION
C			* * * * *
C
C	****  SYSTEM SEGMENT OF MODEL  ****
C
C
	REAL*4 TCOM(25),ITHETA(25),DEPTH(25),COND(25),HPOT(25)
 	REAL*4 AVCOND(25),FLUX(25),NFLUX(25),PPOT(25),DIST(25)
	REAL*4 AVKOND(25),FLOW(25),KOND(25),ITEMP(25),VHCAP(25),IVHCAP(25)
	REAL*4 TVSP1X(14),TVSP1Y(14),TVSC1X(18),TVSC1Y(18)
	REAL*4 TVSP2X(14),TVSP2Y(14),TVSC2X(17),TVSC2Y(17)
	REAL*4 TEVSKX(9),TEVSKY(9),T1VSLX(4),T1VSLY(4)
	REAL*4 INF(38),IVOLH(25),IVOLW(25),NFLOW(25)
	REAL*4 IVOLH1,IVOLW1,NFLOW1,NFLUX1,EMT,HE
	REAL*4 INFILT,MDPNT,KONDV,INCAP,IWATER,RI,ST,RC
	REAL*4 LH,KONDS,KONDW,KONDA,NR,TSC,POROSA,POROSB
	REAL*4 DT,ADT,MO,X,P1,P2,RA,INTGRL,OLDVAL,METPUT(7,324)
	DIMENSION    VOLW(25),THETA(25)
	DIMENSION    TEMP(25),VOLH(25)
	DIMENSION    WINPUT(11,37)
	DIMENSION    RN(38),EVP(38),DRAIN(38)
	EQUIVALENCE  (VOLW1,VOLW(1)),(IVOLW1,IVOLW(1)),(NFLUX1,NFLUX(1))
	EQUIVALENCE  (VOLH1,VOLH(1)),(IVOLH1,IVOLH(1)),(NFLOW1,NFLOW(1))
	INTEGER DNUM,DNUM1,DNUM2,FLAG,FLAG1,ITIME,PITIME

C
C                  * * * * * 
C	
C	****  INITIAL SEGMENT OF MODEL  ****
C 
C		   * * * * * 
C
C
C	****  1)  DEFINITION OF PARAMETERS  ****
C
	FINTIME=1152000.0
C	FINTIME=172800
	DELT=25.0
	TIME=43200.0D00
	HTIME=TIME/3600.0
C 	NA and NB are number of soil layers in A and B 
C	horizons NL is total number of layers
	NA=9
	NAA=NA+1
	NB=5
	NL=NA+NB
	NLL= NL + 1
	KONDS=4.47
	KONDW=0.59
	KONDA=0.025
	VHCAPS=1.021E06
	VHCAPW=4.188E06
	SIGMA=5.67E-08
	ZO=0.00232
	SATCON=3.0E-05
C	POROSA and POROSB are A and B horizon porosity
	POROSA=0.56
	POROSB=0.46
	KONDV=0.0
	UPSLOP=0.0
	DWSLOP=0.0
	MDPNT=0.0
	HEIGHT=0.0
	GR=0.0
	T1=0.0
	ALB=0.0
	EMT=0.0
	SA=0.0
	RA=0.0
	RC=0.0
	RI=0.0
	ST=0.0
	HA=0.0
	HE=0.0
	SH=0.0
	SKL=0.0
	HSO=0.0
	HS=0.0
	RHS=0.0
	EVAP=0.0
	LH=0.0
	NR=0.0
	CUMRN=0.0
	CUMINF=0.0
	CUMEVP=0.0
	CUMDRN=0.0
	A=0.0
	HO=0.0
	EV=0.0
	S=0.0
	TSC=ITEMP(1)
	TAC=TSC
	TAK=TAC+273.16
	DINF=0.0
	DRN=0.0
	DDRN=0.0
	RUNS=0.0
	DEVP=0.0
C
C	****  2)  COUNTERS  ****
C
	DNUM = 1
	DNUM1= 2
	DNUM2= 3
C	Following 4 variables counters for hourly data input
	FLAG = 12
	FLAG1= 13
	ITIME= 0
	PITIME=0
C
C	****  3)  READ INPUT DATA  ****
C
	OPEN(5,FILE='INPUT1.DAT',STATUS='OLD',FORM='FORMATTED')
	DO 10 K=1,14
	READ(5,1000,END=10,ERR=1023)(WINPUT(J,K),J=1,11)
	IF(WINPUT(1,K).EQ.0.0) GO TO 11
10	CONTINUE
	GO TO 1024
1023	PRINT*, 'ERROR READING WINPUT'
1024	CONTINUE
1000 	FORMAT(F3.0,1X,F5.2,9(1X,F4.1))
11	CONTINUE
C
C	Following input file for hourly met. data input
C
	OPEN(6,FILE='MET1.DAT',STATUS='OLD',FORM='FORMATTED')
	DO 15 K=1,323
	READ(6,1015,END=15,ERR=1025)(METPUT(J,K),J=1,6)
	IF(METPUT(1,K).EQ.0.0) GO TO 12
15	CONTINUE
	GOTO 1026
1025	PRINT*,'ERROR READING METPUT'
1026	CONTINUE
1015	FORMAT(9X,F3.0,4X,F5.0,4X,F5.1,4X,F5.2,4X,F5.2,5X,
     1         F4.1)
12 	CONTINUE
C
C	****  4)  SPECIFICATION OF THE GEOMETRY OF THE SYSTEM,
C	          INITIAL WATER CONTENT AND TEMPERATURE  ****
C
	DATA (TCOM(I),I=1,14)/0.01,0.01,0.01,0.01,0.02,0.02,0.02,
     1	               0.02,0.03,0.05,0.05,0.05,0.05,0.05/
	DATA (ITHETA(I),I=1,14)/0.205,0.205,0.261,0.261,0.276,0.282,
     1                 0.282,0.277,0.277,0.279,0.260,0.245,0.230,0.230/
	DATA (ITEMP(I),I=1,14)/22.0,20.6,19.9,19.4,18.6,18.1,17.6,17.3,
     1		       17.1,16.8,16.6,16.6,16.6,16.6/
C
C	****  5)  CALCULATION OF DISTANCE AND DEPTH  ****
C
	DEPTH(1) = 0.5*TCOM(1)
	DIST(1)  = DEPTH(1)
	DO 20 I=2,NL
	DIST(I) = 0.5*(TCOM(I-1)+TCOM(I))
	DEPTH(I) = DEPTH(I-1) + 0.5*(TCOM(I-1)+TCOM(I))
20 	CONTINUE
C
C	****  6)  CALCULATION OF INITIAL WATER AND TEMPERATURE CONDITIONS  ****
C			FLUX REFERS TO WATER
C			FLOW REFERS TO HEAT
C
	IWATER = 0.0
	NFLUX(I)=0.0
	NFLOW(I)=0.0
C
C	Repeated for `A' and `B' horizons
C
	DO 30 I=1,NA
	IVHCAP(I) = VHCAPW*ITHETA(I)+(1.0-POROSA)*VHCAPS
	IWATER = IWATER + TCOM(I)*ITHETA(I)
	IVOLH(I) = ITEMP(I)*TCOM(I)*IVHCAP(I)
	VOLH(I)=IVOLH(I)
	IVOLW(I) = ITHETA(I)*TCOM(I)
	VOLW(I) = IVOLW(I)
	TEMP(I)=ITEMP(I)
30	CONTINUE
	DO 35 I=NAA,NL
	IVHCAP(I) = VHCAPW*ITHETA(I)+(1.0-POROSB)*VHCAPS
	IWATER = IWATER + TCOM(I)*ITHETA(I)
	IVOLH(I) = ITEMP(I)*TCOM(I)*IVHCAP(I)
	VOLH(I)=IVOLH(I)
	IVOLW(I) = ITHETA(I)*TCOM(I)
	VOLW(I) = IVOLW(I)
	TEMP(I)=ITEMP(I)
35	CONTINUE
C
C                             * * * * * * *  
C
C	          HYDRAULIC CHARACTERISTICS OF FIRST HORIZON 0.0-0.15 M
C			VOLUMETRIC WATER CONTENT VS. PRESSURE POTENTIAL
C			IN M WATER COLUMN 
C
	DATA TVSP1X/0.04,0.05,0.06,0.119,0.160,0.172,0.223,
     1       0.255,0.278,0.301,0.325,0.360,0.560,1.00/
	DATA TVSP1Y/-29000.0,-20000.0,-1200.0,-150.00,-50.00,
     1       -30.00,-10.00,-3.33,-1.00,-0.50,-0.30,-0.10,0.0,0.0/
C
C                  * * * * * *
C
C	VOLUMETRIC WATER CONTENT VS. HYDRAULIC CONDUCTIVITY IN M/S
C
C                  * * * * * *
C
	DATA TVSC1X/0.04,0.120,0.140,0.160,0.180,0.200,0.220,
     1       0.240,0.260,0.280,0.300,0.320,0.340,0.360,0.380,
     1       0.400,0.560,1.000/
C
	DATA TVSC1Y/0.155E-15,0.500E-13,0.212E-12,0.897E-12,0.380E-11,
     1       0.161E-10,0.682E-10,0.289E-09,0.122E-08,
     1       0.519E-08,0.220E-07,0.931E-07,0.395E-06,
     1       0.167E-05,0.708E-05,0.300E-04,0.227E01,0.227E01/
C
C                 * * * * * * 
C
C	HYDRAULIC CHARACTERISTICS OF SECOND HORIZON 0.15-0.40 M
C	VOLUMETRIC WATER CONTENT VS. PRESSURE POTENTIAL
C
C                 * * * * * * 
C
	DATA TVSP2X/0.040,0.050,0.060,0.128,0.173,0.184,0.232,0.259,
     1       0.300,0.328,0.343,0.367,0.460,1.000/
	DATA TVSP2Y/-3050.00,-2250.00,-1650.00,-150.00,-50.00,-30.00,
     1       -10.00,-3.33,-1.00,-0.50,-0.30,-0.10,0.00,0.00/
C
C                  * * * * * *
C
C	VOLUMETRIC WATER CONTENT VS. HYDRAULIC CONDUCTIVITY
C
C                  * * * * * * 
C
	DATA TVSC2X/0.040,0.140,0.160,0.180,
     1       0.200,0.220,0.240,0.260,0.280,0.300,0.320,0.340,
     1       0.360,0.380,0.400,0.460,1.000/
	DATA TVSC2Y/0.125E-15,0.160E-12,0.116E-11,
     1       0.527E-11,0.192E-10,0.630E-10,0.214E-09,0.724E-09,
     1       0.241E-08,0.888E-08,0.340E-07,0.123E-06,
     1       0.525E-06,0.285E-05,0.113E-04,0.517E-03,0.517E-03/
C
C             		* * * * * * 
C
C	SOIL TEMPERATURE VS. HEAT CONDUCTIVITY BY VAPOR IN W/(M*C)
C
C         		* * * * * * 
C
	DATA TEVSKX/-1.000,0.000,10.000,20.000,30.000,40.000,50.000,
     1              60.000,70.000/
	DATA TEVSKY/0.02000,0.02470,0.04190,0.07990,0.12600,0.24700,
     1              0.38100,0.65000,1.17000/
C
C                  * * * * * *    
C
C	VOLUMETRIC WATER CONTENT OF FIRST LAYER VS. ALBEDO
C
C		   * * * * * * 
C
	DATA T1VSLX/0.00,0.18,0.22,1.00/
	DATA T1VSLY/0.168,0.168,0.058,0.058/
C
C	****  7)  TABLE OF THE GEOMETRY OF THE SYSTEM AND ITS INITIAL STATE
C
	OPEN(7,FILE='OUTPT2.DAT',STATUS='OLD',FORM='FORMATTED')
	WRITE(7,1100)
1100 	FORMAT('0 I     TCOM    DEPTH     ITHETA    ITEMP')
	DO 40 I=1,NLL
40 	WRITE(7,1200) I,TCOM(I),DEPTH(I),ITHETA(I),ITEMP(I)
1200 	FORMAT(1H ,I2,4F10.5)
C
	OPEN(8,FILE='ENBAL2.DAT',STATUS='OLD',FORM='FORMATTED')
	WRITE(8,1201)
1201	FORMAT(' DAY   TIME     SURFTEMP  NET RAD ')
C
C
C                   * * * * * 
C
C	****  DYNAMIC SEGMENT OF MODEL  ****
C
C                   * * * * * 
C
C	****  1)  DEFINITION OF TIME RELATED VARIABLES
C
6001	CONTINUE
	HTIME=TIME/3600.
	STIME=AMOD(HTIME,24.0)
	IF(STIME.EQ.0.)THEN
	DNUM=DNUM+1
	DNUM1 = DNUM + 1
	DNUM2 = DNUM + 2
	ENDIF
C
C	Next 4 lines set flag to change each hour to use to
C	access hourly met. data array METPUT
C
	ITIME=INT(STIME)
	IF(ITIME.NE.PITIME)FLAG=FLAG+1
	FLAG1=FLAG+1
	IF(TIME.GT.FINTIME)GOTO 99
C
C	****  2)  CALCULATION OF HYDRAULIC CHARACTERISTICS OF FIRST HORIZON
C
	DO 50 I=1,NA
	THETA(I) = VOLW(I)/TCOM(I)
	COND(I)=AFGEN(TVSC1X,TVSC1Y,THETA(I))
	PPOT(I)=AFGEN( TVSP1X,TVSP1Y,THETA(I))
	HPOT(I)=PPOT(I)-DEPTH(I)
50 	CONTINUE
C
C
C	****  3)  CALCULATION OF HYDRAULIC CHARACTERISTICS OF SECOND HORIZON
C
	DO 60 I=NAA,NL
	THETA(I) = VOLW(I)/TCOM(I)
	COND(I)=AFGEN(TVSC2X,TVSC2Y,THETA(I))
	PPOT(I)=AFGEN( TVSP2X,TVSP2Y,THETA(I))
	HPOT(I)=PPOT(I)-DEPTH(I)
60 	CONTINUE
C
C	****  4)  CALCULATION OF THERMAL PROPERTIES  ****
C
C	Repeated for `A' and `B' horizons
C
	DO 70 I=1,NA
	VHCAP(I) = VHCAPW*THETA(I) + (1.0 - POROSA)*VHCAPS
	TEMP(I) = VOLH(I)/(VHCAP(I)*TCOM(I))
	KONDV = AFGEN (TEVSKX,TEVSKY,TEMP(I))
	KOND(I) = ((1. -POROSA)*KONDS*0.4 + THETA(I)*KONDW +
     1  (POROSA - THETA(I))*1.4*(KONDA + KONDV))/ 
     2  ((1.-POROSA)*0.4+THETA(I)+(POROSA-THETA(I))*1.4)
70 	CONTINUE
	DO 75 I=NAA,NL
	VHCAP(I) = VHCAPW*THETA(I) + (1.0 - POROSB)*VHCAPS
	TEMP(I) = VOLH(I)/(VHCAP(I)*TCOM(I))
	KONDV = AFGEN (TEVSKX,TEVSKY,TEMP(I))
	KOND(I) = ((1. -POROSB)*KONDS*0.4 + THETA(I)*KONDW +
     1  (POROSB - THETA(I))*1.4*(KONDA + KONDV))/
     2  ((1.-POROSB)*0.4+THETA(I)+(POROSB-THETA(I))*1.4)
75	CONTINUE
C
C	****  5)  CALCULATION OF AVERAGE CONDUCTIVITIES  ****
C
	DO 80 I = 2,NL
	AVKOND(I) = (TCOM(I-1)+TCOM(I))/(TCOM(I-1)/KOND(I-1) 
     1  + TCOM(I)/KOND(I))
	AVCOND(I)=(COND(I-1)*TCOM(I-1)+COND(I)*TCOM(I))/
     2  (TCOM(I-1)+TCOM(I))
80 	CONTINUE
C
C	****  6)  SPECIFICATION OF BOUNDARY CONDITIONS FOR FLOW OF HEAT
C			AND FLUX OF WATER  ****
C
	FLUX(NLL)= COND(NL)
	FLOW(NLL)=(TEMP(NL)-ITEMP(NL))*KOND(NL)/(TCOM(NL)/2.)
C
C	****  7)  CALCULATION OF FLOW OF HEAT AND FLUX OF WATER  ****
C
	DO 90 I = 2,NL
	FLOW(I) = (TEMP(I-1) - TEMP(I))*AVKOND(I)/DIST(I)
	FLUX(I)=(HPOT(I-1)-HPOT(I))*AVCOND(I)/DIST(I)
90 	CONTINUE
C
C
C	****  8)  USE DAILY RAINFALL DATA, AND CALCULATE DAILY
C			RAINFALL DISTRIBUTION  ****
C
	BEGIN = WINPUT(9,DNUM)
	END = WINPUT(10,DNUM)
	RFT = WINPUT(11,DNUM)
	RAIN=0.0
	IF (RFT.EQ.0.0) GO TO 33
	UPSLOP=(4.0*RFT)/((END-BEGIN)**2)
	DWSLOP=-UPSLOP
	MDPNT=(BEGIN+END)/2.0
	HEIGHT=(2.0*RFT)/(END-BEGIN)
	IF (STIME.GE.BEGIN.AND.STIME.LE.MDPNT)RAIN=
     1    (UPSLOP*(STIME-BEGIN))/3600000.0
	IF (STIME.GT.MDPNT.AND.STIME.LE.END)RAIN=
     1    (DWSLOP*(STIME-END))/3600000.0
33 	CONTINUE
C
C
C	****  9)  USE DAY LENGTH AND CALCULATE DAILY DISTRIBUTION OF
C			GLOBAL RADIATION  ****
C
C	DL=WINPUT(2,DNUM)
C	DGR/86400.*1.E06*24./DL*PI/2.=436.33*DGR/DL
C	GR=436.33*WINPUT(3,DNUM)/DL*SIN((STIME-12.+DL/2.)
C    1  *3.141/DL)
C
C	Hourly GR input, interpolates between hourly values
C
	IF(ITIME.NE.STIME)GOTO 222
	GR=METPUT(3,FLAG)
	GOTO 333
222	CONTINUE
	GR=METPUT(3,FLAG)+(METPUT(3,FLAG1)-METPUT(3,FLAG))
     1       *((STIME-ITIME)/1)
333	CONTINUE
	IF (GR.LE.0.0) GR = 0.0
C
C
C	**** 10)  CALCULATION OF ALBEDO AND EMITTANCE ****
C
	T1 = THETA(1)
	ALB =AFGEN(T1VSLX,T1VSLY,T1)
C
	EMT=0.90+(0.18*THETA(1))
C
C	**** 11)  CALCULATION OF WINDSPEED AND BOUNDARY LAYER RESISTANCE  ****
C
C	IF(HTIME.LE.12.) SA=WINPUT(8,DNUM)
C	IF(HTIME.LE.12.) GO TO 44
C	IF(STIME.LE.12.)SA=WINPUT(8,DNUM-1)+(STIME+12.)/24.* 
C    1    (WINPUT(8,DNUM)-WINPUT(8,DNUM-1))
C	IF(STIME.LE.12.) GO TO 44
C	SA=WINPUT(8,DNUM)+(STIME-12.)/24.*(WINPUT(8,DNUM+1)-
C    2     WINPUT(8,DNUM))
C44 	CONTINUE
C
C	Hourly SA input, interpolates between hourly values
C
	IF(ITIME.NE.STIME)GOTO 444
	SA=METPUT(6,FLAG)
	GOTO 555
444	CONTINUE
	SA=METPUT(6,FLAG)+(METPUT(6,FLAG1)-METPUT(6,FLAG))
     1      *((STIME-ITIME)/1)
555	CONTINUE
C
C	Stability correction (Richardson number)
C
C	RI = (9.81*(2.0-ZO)*(TAC-TSC))/((TAC+273.16)*(SA*SA))
C	ST = 1/(1-(10*RI))
C	RC = (ALOG(2.0/ZO)**2.0)/(0.16*SA)
C	RA = RC*ST
C
C	Stability correction (Monin-Oblikhov)
C
	DT=TAC-TSC
	ADT=ABS(DT)
	IF(ADT.LE.0.1)THEN
		P1=0.0
		P2=0.0
		GOTO 565
	ENDIF
	MO=(TAK*(SA*SA))/(9.81*DT*ALOG(2.0/ZO))
	IF(DT.LE.-0.1)THEN
		X=(1.-(16.*(2.0/MO)))**0.25
		P1=(2*ALOG((1+X)/2))+(ALOG((1+(X*X))/2))-
     1              (2*ATAN(X))+(3.141/2)
		P2=2*ALOG((1+(X*X))/2)
		GOTO 565
	ENDIF
	IF(DT.GT.0.1)THEN
		IF((2.0/MO).GT.1.0)THEN
			P1=-5.0*ALOG(2.0/ZO)
			P2=P1
		ELSE
		P1=(-5.0*(2.0-ZO))/MO
		P2=P1
		ENDIF
	ENDIF
565	CONTINUE
	RA=((ALOG(2.0/ZO)-P1)*(ALOG(2.0/ZO)-P2))/((0.16)*SA)
C
C	**** 12)  CALCULATION OF DEWPOINT TEMPERATURE AND ABSOLUTE HUMIDITY
C
C	DPMAX=WINPUT(6,DNUM)
C	DPMIN=WINPUT(7,DNUM)
C	DPTC=DPMIN+(DPMAX-DPMIN)*(STIME-5.)/10.
C	IF(STIME.GT.15.)DPMIN=WINPUT(7,DNUM+1)
C	IF(STIME.GT.15.)DPTC=DPMAX-(DPMAX-DPMIN)*(STIME-15.)/14.
C	IF(STIME.LT.5.AND.DNUM.GE.2.)DPMAX=WINPUT(6,DNUM-1)
C	IF(STIME.LT.5.)DPTC=DPMAX-(DPMAX-DPMIN)*(STIME+9.)/14.
C
C	Hourly DPTC input, interpolates between hourly values
C
	IF(ITIME.NE.STIME)GOTO 666
	DPTC=METPUT(5,FLAG)
	GOTO 777
666	CONTINUE
	DPTC=METPUT(5,FLAG)+(METPUT(5,FLAG1)-METPUT(5,FLAG))
     1        *((STIME-ITIME)/1)
777	CONTINUE
	HA = 1.323*EXP(17.27*DPTC/(237.3+DPTC))/(273.16+DPTC)
C
C	**** 13)  CALCULATION OF TEMPERATURE OF THE AIR AND SH OF THE AIR
C
C	TAMAX=WINPUT(4,DNUM)
C	TAMIN=WINPUT(5,DNUM)
C	TAC=TAMIN+(TAMAX-TAMIN)*(STIME-5.)/10.
C	IF(STIME.GT.15.)TAMIN=WINPUT(5,DNUM+1)
C	IF(STIME.GT.15.)TAC=TAMAX-(TAMAX-TAMIN)*(STIME-15.)/14.
C	IF(STIME.LT.5.AND.DNUM.GE.2.)TAMAX=WINPUT(4,DNUM-1)
C	IF(STIME.LT.5.)TAC=TAMAX-(TAMAX-TAMIN)*(STIME+9.)/14.
C
C	Hourly TAC input, interpolates between hourly values
C
	IF(STIME.NE.ITIME)GOTO 888
	TAC=METPUT(4,FLAG)
	GOTO 999
888	CONTINUE
	TAC=METPUT(4,FLAG)+(METPUT(4,FLAG1)-METPUT(4,FLAG))
     1       *((STIME-ITIME)/1)
999	CONTINUE
	TAK=TAC+273.16
	SH=(1154.8*303.16)/(TAK)
C
C	**** 14)  CALCULATION OF SKY IRRADIANCE  ****
C
C	Brunt or Idso (1981) formula
C
	HE=((HA*1000)*TAK)/217.0
C
	SKL=(EMT*SIGMA*TAK**4)*(0.7+5.95E-05*(HE*EXP(1500./TAK)))
C
C	SKL=(EMT*SIGMA*TAK**4)*(0.605+0.039*SQRT(1410.*HA))
C
C	SKL=(SIGMA*TAK**4)*(0.605+0.039*SQRT(1410.*HA))
C
C	SKL=(EMT*SIGMA*TAK**4)*(0.605+0.048*SQRT(HE))
C
C
C	**** 15)  IMPLICIT CALCULATION OF THE SOIL SURFACE TEMPERATURE  ****
C
334	CONTINUE
	TSC1=TSC
	A   =  (TSC - TAC)*SH/RA
	HO = 1.323*EXP(17.27*TSC /(237.3+TSC ))/(273.16+TSC )
	HO=HO*EXP(PPOT(1)/(46.97*(TSC+273.16)))
	EV =(HO - HA)/(RA*1000.)
C
	S=GR*(1.-ALB)+SKL-EMT*SIGMA*(TSC+273.16)**4-A-LH*EV
C
C	S=GR*(1.-ALB)+SKL-SIGMA*(TSC+273.16)**4-A-LH*EV
	FTSC = TEMP(1) + S*DEPTH(1)/KOND(1)
	TSC=FTSC
	QS=QS+1
	IF(QS.GT.25)THEN
		PRINT*, 'STUCK IN LOOP!!'
		GO TO 99
	ENDIF
	IF(ABS((TSC-TSC1)/TSC1).GT.0.01)GOTO 334
	QS=0.0
C
C
C	**** 16)  CALCULATION OF EVAPORATION AND NET RADIATION  ****
C
	FLOW(1) = (TSC - TEMP(1))*KOND(1)/DIST(1)
	HS = 1.323*EXP(17.27*TSC /(237.3+TSC ))/(273.16+TSC )
	HSO = HS
	HS=HS*EXP(PPOT(1)/(46.97*(TSC+273.16)))
	RHS = HS/HSO
	EVAP = (HS - HA)/(RA*1000.)
	LH=2.49463E09-2.247E06*TSC
	NR = FLOW(1) + (TSC - TAC)*SH/RA + LH*EVAP
C
C	**** 17)  CALCULATION OF DETAIN, INFILTRATION, AND INCAP  ****
C
	DETAIN = INTGRL (DETAIN, RAIN-INFILT,DELT)
	INCAP = (0.-HPOT(1))*0.5*(SATCON+COND(1)) / DIST(1)
	IF (RAIN.GE.0.0) GO TO 55
	IF (DETAIN.LE.0.0) GO TO 66
	INFILT=INCAP
	GO TO 77
66 	CONTINUE
	DETAIN = 0.0
	INFILT=0.0
	GO TO 77
55 	CONTINUE
	INFILT = INCAP
	IF (RAIN. LT. INCAP)INFILT=RAIN
77 	CONTINUE
C
C	**** 18)  CALCULATION OF NET FLOW OF HEAT AND NET FLUX OF WATER
C
	FLUX(1)=INFILT-EVAP
	DO 100 I = 1,NL
	NFLOW(I)  =  FLOW(I) - FLOW(I+1)
	NFLUX(I)=FLUX(I)-FLUX(I+1)
100 	CONTINUE
C
C	**** 19)  INTEGRATION OF VOLUMETRIC HEAT CONTENT AND VOLUMETRIC
C			WATER CONTENT  ****
C
	DO 111 I=1,NL
	VOLH(I)=INTGRL(VOLH(I),NFLOW(I),DELT)
	VOLW(I)=INTGRL(VOLW(I),NFLUX(I),DELT)
111	CONTINUE
C
C	**** 20)  CALCULATION OF CUMULATIVE RAIN, INFILTRATION, EVAPORATION
C			AND DRAINAGE  ****
C
	CUMRN = INTGRL  (CUMRN,RAIN,DELT)
	CUMINF = INTGRL (CUMINF, INFILT,DELT)
	CUMEVP = INTGRL (CUMEVP, EVAP ,DELT)
	CUMDRN = INTGRL (CUMDRN, FLUX(NLL),DELT)
C
C	**** 21)  CALCULATION OF TOTAL WATER FOR DIFFERENT LAYERS  ****
C
	CUMWTR = 0.0
	CUMWT1 = 0.0
	CUMWT2 = 0.0
	CUMWT3 = 0.0
	DO 110 I=1,NL
	CUMWTR= CUMWTR + VOLW(I)
110 	CONTINUE
	DO 120 I=6,NL
	CUMWT1 = CUMWT1 + VOLW(I)
120 	CONTINUE
	DO 130 I=9,NL
	CUMWT2 = CUMWT2 + VOLW(I)
130 	CONTINUE
	DO 140 I=12,NL
	CUMWT3 = CUMWT3 + VOLW(I)
140 	CONTINUE
C
C
C	**** 22)  CALCULATION OF DAILY TOTALS  ****
C
	IF (STIME.NE.24.0) GOTO 88
	INF(DNUM-1)=CUMINF
	RN(DNUM-1)=CUMRN
	EVP(DNUM-1)=CUMEVP
	DRAIN(DNUM-1)=CUMDRN
	DINF=CUMINF-INF(DNUM-2)
	DRN=CUMRN-RN(DNUM-2)
	DEVP=CUMEVP-EVP(DNUM-2)
	DDRN=CUMDRN-DRAIN(DNUM-2)
88 	CONTINUE
C
C	**** 23)  CHECK WATER BALANCE  ****
C
	BALANS = CUMWTR - IWATER - CUMINF + CUMEVP + CUMDRN
C
C	**** 24)  OUTPUT OF DESIRED VARIABLES  ****
C
	IF(ITIME.EQ.PITIME)GOTO 986
	WRITE(8,900)WINPUT(1,DNUM),HTIME,TEMP(1),NR
900	FORMAT(F4.0,2X,F7.0,2X,F7.2,2X,F8.2)
986	CONTINUE
	Z=TIME-(86400.0*(DNUM-1))
	IF(Z.EQ.00000.0.OR.Z.EQ.43200.0)GOTO 987
	IF(Z.EQ.28800.0.OR.Z.EQ.57600.0)GOTO 987
	GOTO 6000
987	CONTINUE
	WRITE(7,1300) WINPUT(1,DNUM),TIME,STIME
1300 	FORMAT(' JULIAN DAY NUMBER = ',F4.0,' TIME = ',F10.1,
     $       ' STIME = ',F7.4)
	WRITE(7,1400)
1400 	FORMAT('0 I ',5X,'DEPTH',10X,'THETA',11X,'PPOT',11X,
     $       'FLUX',9X,'NET FLUX',10X,'TEMP')
	DO 150 I=1,NL
 	WRITE(7,1500) I,DEPTH(I),THETA(I),PPOT(I),FLUX(I), 
     1        	      NFLUX(I),TEMP(I)
150	CONTINUE
1500 	FORMAT( I3,6E15.4)
	WRITE(7,1600) CUMEVP
1600	FORMAT(' CUM EVAP  m = ',F8.4)
C
C       *** TIME UPDATE ***
C
6000	CONTINUE
	PITIME=ITIME
	TIME=TIME+DELT
	GO TO 6001
C 
C
C                        * * * * *
C
C	****  TERMINAL SEGMENT OF MODEL  ****
C
C                        * * * * * 
C
99 	CONTINUE
	STOP
	END
C
	FUNCTION AFGEN(XVAL,YVAL,ARG)
	REAL NEWX,NEWY,OLDX,OLDY
	DIMENSION XVAL(1),YVAL(1)
	OLDX = XVAL(1)
	OLDY = YVAL(1)
	DO 101 I = 2,400
	NEWX = XVAL(I)
	IF (ARG.LT.XVAL(I)) GOTO 102
	OLDX = NEWX
101	CONTINUE
102	CONTINUE
	IF (OLDX.EQ.NEWX) OLDX = OLDX - 1.0E-05
	IF (OLDX.EQ.ARG) OLDX = OLDX - 1.0E-05
	NEWY = YVAL(I)
	OLDY = YVAL(I-1)
	AFGEN = OLDY + ((NEWY-OLDY)/(NEWX-OLDX) * (ARG-OLDX))
	RETURN
	END
C
	FUNCTION INTGRL(OLDVAL,DERIV,DELT)
	REAL*4 INTGRL,OLDVAL
	INTGRL = OLDVAL + DERIV*DELT
	RETURN
	END
C
	FUNCTION AMOD(INPUT,INPUTD)
	REAL INPUT,INPUTD
	AMOD=INPUT
	DO 10 I=1,1000
	IF(AMOD.GT.INPUTD)AMOD=AMOD-INPUTD
10	CONTINUE
	RETURN
	END
C
